"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const rimraf = require("rimraf");
const util_1 = require("util");
const StorageErrorFactory_1 = tslib_1.__importDefault(require("../../blob/errors/StorageErrorFactory"));
// LokiFsStructuredAdapter
// tslint:disable-next-line:no-var-requires
exports.lfsa = require("lokijs/src/loki-fs-structured-adapter.js");
exports.rimrafAsync = util_1.promisify(rimraf);
function minDate(date1, date2) {
    return date1 > date2 ? date2 : date1;
}
exports.minDate = minDate;
function checkApiVersion(inputApiVersion, validApiVersions, requestId) {
    if (!validApiVersions.includes(inputApiVersion)) {
        throw StorageErrorFactory_1.default.getInvalidHeaderValue(requestId, {
            HeaderName: "x-ms-version",
            HeaderValue: inputApiVersion
        });
    }
}
exports.checkApiVersion = checkApiVersion;
// Blob Snapshot is has 7 digital for Milliseconds, but Datatime has Milliseconds with 3 digital. So need convert.
function convertDateTimeStringMsTo7Digital(dateTimeString) {
    return dateTimeString.replace("Z", "0000Z");
}
exports.convertDateTimeStringMsTo7Digital = convertDateTimeStringMsTo7Digital;
//# sourceMappingURL=utils.js.map