/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

// tslint:disable:quotemark
// tslint:disable:object-literal-sort-keys

import * as msRest from "@azure/ms-rest-js";

export const comp0: msRest.OperationQueryParameter = {
  parameterPath: "comp",
  mapper: {
    required: true,
    isConstant: true,
    serializedName: "comp",
    defaultValue: 'properties',
    type: {
      name: "String"
    }
  }
};
export const comp1: msRest.OperationQueryParameter = {
  parameterPath: "comp",
  mapper: {
    required: true,
    isConstant: true,
    serializedName: "comp",
    defaultValue: 'stats',
    type: {
      name: "String"
    }
  }
};
export const comp2: msRest.OperationQueryParameter = {
  parameterPath: "comp",
  mapper: {
    required: true,
    isConstant: true,
    serializedName: "comp",
    defaultValue: 'list',
    type: {
      name: "String"
    }
  }
};
export const comp3: msRest.OperationQueryParameter = {
  parameterPath: "comp",
  mapper: {
    required: true,
    isConstant: true,
    serializedName: "comp",
    defaultValue: 'metadata',
    type: {
      name: "String"
    }
  }
};
export const comp4: msRest.OperationQueryParameter = {
  parameterPath: "comp",
  mapper: {
    required: true,
    isConstant: true,
    serializedName: "comp",
    defaultValue: 'acl',
    type: {
      name: "String"
    }
  }
};
export const include: msRest.OperationQueryParameter = {
  parameterPath: [
    "options",
    "include"
  ],
  mapper: {
    serializedName: "include",
    type: {
      name: "Sequence",
      element: {
        type: {
          name: "Enum",
          allowedValues: [
            "metadata"
          ]
        }
      }
    }
  },
  collectionFormat: msRest.QueryCollectionFormat.Csv
};
export const marker: msRest.OperationQueryParameter = {
  parameterPath: [
    "options",
    "marker"
  ],
  mapper: {
    serializedName: "marker",
    type: {
      name: "String"
    }
  }
};
export const maxresults: msRest.OperationQueryParameter = {
  parameterPath: [
    "options",
    "maxresults"
  ],
  mapper: {
    serializedName: "maxresults",
    constraints: {
      InclusiveMinimum: 1
    },
    type: {
      name: "Number"
    }
  }
};
export const messageTimeToLive: msRest.OperationQueryParameter = {
  parameterPath: [
    "options",
    "messageTimeToLive"
  ],
  mapper: {
    serializedName: "messagettl",
    constraints: {
      InclusiveMinimum: -1
    },
    type: {
      name: "Number"
    }
  }
};
export const metadata: msRest.OperationParameter = {
  parameterPath: [
    "options",
    "metadata"
  ],
  mapper: {
    serializedName: "x-ms-meta",
    type: {
      name: "Dictionary",
      value: {
        type: {
          name: "String"
        }
      }
    },
    headerCollectionPrefix: "x-ms-meta-"
  }
};
export const numberOfMessages: msRest.OperationQueryParameter = {
  parameterPath: [
    "options",
    "numberOfMessages"
  ],
  mapper: {
    serializedName: "numofmessages",
    constraints: {
      InclusiveMinimum: 1
    },
    type: {
      name: "Number"
    }
  }
};
export const peekonly: msRest.OperationQueryParameter = {
  parameterPath: "peekonly",
  mapper: {
    required: true,
    isConstant: true,
    serializedName: "peekonly",
    defaultValue: 'true',
    type: {
      name: "String"
    }
  }
};
export const popReceipt: msRest.OperationQueryParameter = {
  parameterPath: "popReceipt",
  mapper: {
    required: true,
    serializedName: "popreceipt",
    type: {
      name: "String"
    }
  }
};
export const prefix: msRest.OperationQueryParameter = {
  parameterPath: [
    "options",
    "prefix"
  ],
  mapper: {
    serializedName: "prefix",
    type: {
      name: "String"
    }
  }
};
export const requestId: msRest.OperationParameter = {
  parameterPath: [
    "options",
    "requestId"
  ],
  mapper: {
    serializedName: "x-ms-client-request-id",
    type: {
      name: "String"
    }
  }
};
export const restype: msRest.OperationQueryParameter = {
  parameterPath: "restype",
  mapper: {
    required: true,
    isConstant: true,
    serializedName: "restype",
    defaultValue: 'service',
    type: {
      name: "String"
    }
  }
};
export const timeout: msRest.OperationQueryParameter = {
  parameterPath: [
    "options",
    "timeout"
  ],
  mapper: {
    serializedName: "timeout",
    constraints: {
      InclusiveMinimum: 0
    },
    type: {
      name: "Number"
    }
  }
};
export const url: msRest.OperationURLParameter = {
  parameterPath: "url",
  mapper: {
    required: true,
    serializedName: "url",
    defaultValue: '',
    type: {
      name: "String"
    }
  },
  skipEncoding: true
};
export const version: msRest.OperationParameter = {
  parameterPath: "version",
  mapper: {
    serializedName: "x-ms-version",
    type: {
      name: "String"
    }
  }
};
export const visibilitytimeout0: msRest.OperationQueryParameter = {
  parameterPath: [
    "options",
    "visibilitytimeout"
  ],
  mapper: {
    serializedName: "visibilitytimeout",
    constraints: {
      InclusiveMaximum: 604800,
      InclusiveMinimum: 0
    },
    type: {
      name: "Number"
    }
  }
};
export const visibilitytimeout1: msRest.OperationQueryParameter = {
  parameterPath: "visibilitytimeout",
  mapper: {
    required: true,
    serializedName: "visibilitytimeout",
    constraints: {
      InclusiveMaximum: 604800,
      InclusiveMinimum: 0
    },
    type: {
      name: "Number"
    }
  }
};
