/// <reference types="node" />
import ConfigurationBase from "../common/ConfigurationBase";
import { StoreDestinationArray } from "../common/persistence/IExtentStore";
/**
 * Default configurations for default implementation of BlobServer.
 *
 * As default implementation of BlobServer class leverages LokiJS DB.
 * This configuration class also maintains configuration settings for LokiJS DB.
 *
 * When creating other server implementations, should also create a NEW
 * corresponding configuration class by extending ConfigurationBase.
 *
 * @export
 * @class Configuration
 */
export default class BlobConfiguration extends ConfigurationBase {
    readonly metadataDBPath: string;
    readonly extentDBPath: string;
    readonly persistencePathArray: StoreDestinationArray;
    constructor(host?: string, port?: number, metadataDBPath?: string, extentDBPath?: string, persistencePathArray?: StoreDestinationArray, enableAccessLog?: boolean, accessLogWriteStream?: NodeJS.WritableStream, enableDebugLog?: boolean, debugLogFilePath?: string, loose?: boolean);
}
//# sourceMappingURL=BlobConfiguration.d.ts.map