/// <reference types="node" />
import IAccountDataStore from "../common/IAccountDataStore";
import IRequestListenerFactory from "../common/IRequestListenerFactory";
import IExtentStore from "../common/persistence/IExtentStore";
import { RequestListener } from "../common/ServerBase";
import IBlobMetadataStore from "./persistence/IBlobMetadataStore";
/**
 * Default RequestListenerFactory based on express framework.
 *
 * When creating other server implementations, such as based on Koa. Should also create a NEW
 * corresponding BlobKoaRequestListenerFactory class by extending IRequestListenerFactory.
 *
 * @export
 * @class BlobRequestListenerFactory
 * @implements {IRequestListenerFactory}
 */
export default class BlobRequestListenerFactory implements IRequestListenerFactory {
    private readonly metadataStore;
    private readonly extentStore;
    private readonly accountDataStore;
    private readonly enableAccessLog;
    private readonly accessLogWriteStream?;
    private readonly loose?;
    constructor(metadataStore: IBlobMetadataStore, extentStore: IExtentStore, accountDataStore: IAccountDataStore, enableAccessLog: boolean, accessLogWriteStream?: NodeJS.WritableStream | undefined, loose?: boolean | undefined);
    createRequestListener(): RequestListener;
}
//# sourceMappingURL=BlobRequestListenerFactory.d.ts.map