/// <reference types="node" />
import { OutgoingHttpHeaders } from "http";
export default class MiddlewareError extends Error {
    readonly statusCode: number;
    readonly message: string;
    readonly statusMessage?: string | undefined;
    readonly headers?: OutgoingHttpHeaders | undefined;
    readonly body?: string | undefined;
    readonly contentType?: string | undefined;
    /**
     * Creates an instance of MiddlewareError.
     *
     * @param {number} statusCode HTTP response status code
     * @param {string} message Error message
     * @param {string} [statusMessage] HTTP response status message
     * @param {OutgoingHttpHeaders} [headers] HTTP response headers
     * @param {string} [body] HTTP response body
     * @param {string} [contentType] HTTP contentType
     * @memberof MiddlewareError
     */
    constructor(statusCode: number, message: string, statusMessage?: string | undefined, headers?: OutgoingHttpHeaders | undefined, body?: string | undefined, contentType?: string | undefined);
}
//# sourceMappingURL=MiddlewareError.d.ts.map