import Context from "../Context";
import IHandlers from "../handlers/IHandlers";
import { NextFunction } from "../MiddlewareFactory";
import ILogger from "../utils/ILogger";
/**
 * Auto generated. HandlerMiddlewareFactory will accept handlers and create handler middleware.
 *
 * @export
 * @class HandlerMiddlewareFactory
 */
export default class HandlerMiddlewareFactory {
    private readonly handlers;
    private readonly logger;
    /**
     * Creates an instance of HandlerMiddlewareFactory.
     * Accept handlers and create handler middleware.
     *
     * @param {IHandlers} handlers Handlers implemented handler interfaces
     * @param {ILogger} logger A valid logger
     * @memberof HandlerMiddlewareFactory
     */
    constructor(handlers: IHandlers, logger: ILogger);
    /**
     * Creates a handler middleware from input handlers.
     *
     * @memberof HandlerMiddlewareFactory
     */
    createHandlerMiddleware(): (context: Context, next: NextFunction) => void;
}
//# sourceMappingURL=HandlerMiddlewareFactory.d.ts.map