/// <reference types="node" />
import { StoreDestinationArray } from "../../common/persistence/IExtentStore";
import * as Models from "../generated/artifacts/models";
export declare const VERSION = "3.4.0";
export declare const BLOB_API_VERSION = "2019-02-02";
export declare const DEFAULT_BLOB_SERVER_HOST_NAME = "127.0.0.1";
export declare const DEFAULT_LIST_BLOBS_MAX_RESULTS = 5000;
export declare const DEFAULT_LIST_CONTAINERS_MAX_RESULTS = 5000;
export declare const DEFAULT_BLOB_LISTENING_PORT = 10000;
export declare const IS_PRODUCTION: boolean;
export declare const DEFAULT_BLOB_LOKI_DB_PATH = "__azurite_db_blob__.json";
export declare const DEFAULT_BLOB_EXTENT_LOKI_DB_PATH = "__azurite_db_blob_extent__.json";
export declare const DEFAULT_BLOB_PERSISTENCE_PATH = "__blobstorage__";
export declare const DEFAULT_DEBUG_LOG_PATH = "./debug.log";
export declare const DEFAULT_ENABLE_DEBUG_LOG = true;
export declare const DEFAULT_ACCESS_LOG_PATH = "./access.log";
export declare const DEFAULT_ENABLE_ACCESS_LOG = true;
export declare const DEFAULT_CONTEXT_PATH = "azurite_blob_context";
export declare const LOGGER_CONFIGS: {};
export declare const DEFAULT_GC_INTERVAL_MS: number;
export declare const DEFAULT_WRITE_CONCURRENCY_PER_LOCATION = 50;
export declare const EMULATOR_ACCOUNT_NAME = "devstoreaccount1";
export declare const EMULATOR_ACCOUNT_KEY: Buffer;
export declare const EMULATOR_ACCOUNT_SKUNAME = Models.SkuName.StandardRAGRS;
export declare const EMULATOR_ACCOUNT_KIND = Models.AccountKind.StorageV2;
export declare const HeaderConstants: {
    AUTHORIZATION: string;
    AUTHORIZATION_SCHEME: string;
    CONTENT_ENCODING: string;
    CONTENT_LANGUAGE: string;
    CONTENT_LENGTH: string;
    CONTENT_MD5: string;
    CONTENT_TYPE: string;
    COOKIE: string;
    DATE: string;
    IF_MATCH: string;
    IF_MODIFIED_SINCE: string;
    IF_NONE_MATCH: string;
    IF_UNMODIFIED_SINCE: string;
    SOURCE_IF_MATCH: string;
    SOURCE_IF_MODIFIED_SINCE: string;
    SOURCE_IF_NONE_MATCH: string;
    SOURCE_IF_UNMODIFIED_SINCE: string;
    X_MS_IF_SEQUENCE_NUMBER_LE: string;
    X_MS_IF_SEQUENCE_NUMBER_LT: string;
    X_MS_IF_SEQUENCE_NUMBER_EQ: string;
    X_MS_BLOB_CONDITION_MAXSIZE: string;
    X_MS_BLOB_CONDITION_APPENDPOS: string;
    X_MS_CONTENT_CRC64: string;
    X_MS_RANGE_GET_CONTENT_CRC64: string;
    X_MS_ENCRYPTION_KEY: string;
    X_MS_ENCRYPTION_KEY_SHA256: string;
    X_MS_ENCRYPTION_ALGORITHM: string;
    PREFIX_FOR_STORAGE: string;
    RANGE: string;
    USER_AGENT: string;
    X_MS_CLIENT_REQUEST_ID: string;
    X_MS_DATE: string;
    SERVER: string;
    X_MS_META: string;
    X_MS_VERSION: string;
    ORIGIN: string;
    VARY: string;
    ACCESS_CONTROL_EXPOSE_HEADERS: string;
    ACCESS_CONTROL_ALLOW_ORIGIN: string;
    ACCESS_CONTROL_ALLOW_CREDENTIALS: string;
    ACCESS_CONTROL_ALLOW_METHODS: string;
    ACCESS_CONTROL_ALLOW_HEADERS: string;
    ACCESS_CONTROL_MAX_AGE: string;
    ACCESS_CONTROL_REQUEST_METHOD: string;
    ACCESS_CONTROL_REQUEST_HEADERS: string;
};
export declare const MethodConstants: {
    OPTIONS: string;
};
export declare const SECONDARY_SUFFIX = "-secondary";
export declare const DEFAULT_BLOB_PERSISTENCE_ARRAY: StoreDestinationArray;
export declare const ValidAPIVersions: string[];
//# sourceMappingURL=constants.d.ts.map