import IVSCServerManagerCommands from "./IVSCServerManagerCommands";
import IVSCServerManagerEventsHandler from "./IVSCServerManagerEventsHandler";
import IVSCServerManagerState from "./IVSCServerManagerState";
import ServerBase from "./ServerBase";
export default abstract class VSCServerManagerBase implements IVSCServerManagerCommands {
    readonly name: string;
    protected state: IVSCServerManagerState;
    protected server?: ServerBase | undefined;
    private handlers;
    private startSession;
    private closeSession;
    private cleanSession;
    constructor(name: string, state: IVSCServerManagerState, server?: ServerBase | undefined);
    getStartCommand(): string;
    getCloseCommand(): string;
    getCleanCommand(): string;
    addEventListener(handler: IVSCServerManagerEventsHandler): void;
    getServer(): ServerBase | undefined;
    abstract createImpl(): Promise<void>;
    abstract startImpl(): Promise<void>;
    abstract closeImpl(): Promise<void>;
    abstract cleanImpl(): Promise<void>;
    start(): Promise<void>;
    close(): Promise<void>;
    clean(): Promise<void>;
    protected onStart(session: number): void;
    protected onStartFail(session: number, error: Error): void;
    protected onStartSuccess(session: number): void;
    protected onClean(session: number): void;
    protected onCleanFail(session: number, error: Error): void;
    protected onCleanSuccess(session: number): void;
    protected onClose(session: number): void;
    protected onCloseFail(session: number, error: Error): void;
    protected onCloseSuccess(session: number): void;
}
//# sourceMappingURL=VSCServerManagerBase.d.ts.map