import ILoggerStrategy, { LogLevels } from "./ILoggerStrategy";
/**
 * A logger strategy can log to console or file.
 *
 * @export
 * @class WinstonLoggerStrategy
 * @implements {ILoggerStrategy}
 */
export default class WinstonLoggerStrategy implements ILoggerStrategy {
    private readonly winstonLogger;
    private readonly consoleTransport?;
    private readonly fileTransport?;
    /**
     * Creates an instance of WinstonLoggerStrategy.
     *
     * @param {LogLevels} [level=LogLevels.Debug]
     * @param {string} [logfile] Log to specific file, otherwise to console.
     * @memberof WinstonLoggerStrategy
     */
    constructor(level?: LogLevels, logfile?: string);
    log(level: LogLevels, message: string, contextID?: string): void;
}
//# sourceMappingURL=WinstonLoggerStrategy.d.ts.map