import ILogger from "../ILogger";
import IOperationQueue from "./IOperationQueue";
export default class OperationQueue implements IOperationQueue {
    private maxConcurrency;
    private readonly logger;
    private operations;
    private emitter;
    private runningConcurrency;
    constructor(maxConcurrency: number, logger: ILogger);
    /**
     * Add an operation to be executed.
     *
     * @template T
     * @param {Promise<T>} op
     * @param {string} [contextId]
     * @returns {Promise<T>}
     * @memberof OperationQueue
     */
    operate<T>(op: () => Promise<T>, contextId?: string): Promise<T>;
    /**
     * It assists queue to execute the operation.
     *
     * @private
     * @param {string} [contextId]
     * @returns
     * @memberof OperationQueue
     */
    private execute;
}
//# sourceMappingURL=OperationQueue.d.ts.map