import Operation from "./artifacts/operation";
import IRequest from "./IRequest";
import IResponse from "./IResponse";
export interface IHandlerParameters {
    [key: string]: any;
}
/**
 * Context holds generated server context information.
 * Every incoming HTTP request will initialize a new context.
 *
 * @export
 * @class Context
 */
export default class Context {
    readonly context: any;
    readonly path: string;
    /**
     * Creates an instance of Context.
     * Context holds generated server context information.
     * Every incoming HTTP request will initialize a new context.
     *
     * @param {Context} context An existing Context
     * @memberof Context
     */
    constructor(context: Context);
    /**
     * Creates an instance of Context.
     * Context holds generated server context information.
     * Every incoming HTTP request will initialize a new context.
     *
     * @param {Object} holder Holder is an Object which used to keep context information
     * @param {string} [path="context"] holder[path] is used as context object by default
     * @param {IRequest} [req]
     * @param {IResponse} [res]
     * @memberof Context
     */
    constructor(holder: object, path: string, req?: IRequest, res?: IResponse);
    operation: Operation | undefined;
    request: IRequest | undefined;
    dispatchPattern: string | undefined;
    response: IResponse | undefined;
    handlerParameters: IHandlerParameters | undefined;
    handlerResponses: any;
    contextID: string | undefined;
    startTime: Date | undefined;
}
//# sourceMappingURL=Context.d.ts.map