/// <reference types="node" />
import { Request } from "express";
import IRequest, { HttpMethod } from "./IRequest";
export default class ExpressRequestAdapter implements IRequest {
    private readonly req;
    constructor(req: Request);
    getMethod(): HttpMethod;
    getUrl(): string;
    getEndpoint(): string;
    getPath(): string;
    getBodyStream(): NodeJS.ReadableStream;
    getBody(): string | undefined;
    setBody(body: string | undefined): ExpressRequestAdapter;
    getHeader(field: string): string | undefined;
    getHeaders(): {
        [header: string]: string | string[] | undefined;
    };
    getQuery(key: string): string | undefined;
    getProtocol(): string;
}
//# sourceMappingURL=ExpressRequestAdapter.d.ts.map